/*
 * (C) 1995-2004 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */

#include "wrapper.h"

#ifdef ARCH_X86

#define _newsyscall1(type,name,type1,arg1) \
type name(type1 arg1) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1))); \
return (type)__res;\
}

#define _newsyscall2(type,name,type1,arg1,type2,arg2) \
type name(type1 arg1,type2 arg2) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2))); \
return (type)__res;\
}

#define _newsyscall3(type,name,type1,arg1,type2,arg2,type3,arg3) \
type name(type1 arg1,type2 arg2,type3 arg3) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
		  "d" ((long)(arg3))); \
return (type)__res;\
}

#define _newsyscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4))); \
return (type)__res;\
} 

#define _newsyscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5) \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5) \
{ \
long __res; \
__asm__ volatile ("int $0x80" \
	: "=a" (__res) \
	: "0" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4)),"D" ((long)(arg5))); \
return (type)__res;\
}

#define _newsyscall6(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5,type6,arg6) \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5,type6 arg6) \
{ \
long __res; \
__asm__ volatile ("push %%ebp ; movl %%eax,%%ebp ; movl %1,%%eax ; int $0x80 ; pop %%ebp" \
	: "=a" (__res) \
	: "i" (__NR_##name),"b" ((long)(arg1)),"c" ((long)(arg2)), \
	  "d" ((long)(arg3)),"S" ((long)(arg4)),"D" ((long)(arg5)), \
	  "0" ((long)(arg6))); \
return (type)__res;\
}

#elif defined(ARCH_IA64)

static long errno; /* __ia64_syscall sets errno */
extern long __ia64_syscall (long a0, long a1, long a2, long a3, long a4, long nr);

#define _newsyscall1(type,name,type1,arg1)					\
type									\
name (type1 arg1)							\
{									\
	register long dummy2 __asm__ ("out1");				\
	register long dummy3 __asm__ ("out2");				\
	register long dummy4 __asm__ ("out3");				\
	register long dummy5 __asm__ ("out4");				\
	long     ret; 												\
	ret = __ia64_syscall((long) arg1, dummy2, dummy3, dummy4,	\
			      dummy5, __NR_##name);			\
	return (ret < 0) ? -errno : 0; \
}

#define _newsyscall2(type,name,type1,arg1,type2,arg2)			\
type									\
name (type1 arg1, type2 arg2)						\
{									\
	register long dummy3 __asm__ ("out2");				\
	register long dummy4 __asm__ ("out3");				\
	register long dummy5 __asm__ ("out4");				\
	long     ret;												\
	ret = __ia64_syscall((long) arg1, (long) arg2, dummy3, dummy4,	\
			      dummy5, __NR_##name);			\
	return (ret < 0) ? -errno : 0; \
}

#define _newsyscall3(type,name,type1,arg1,type2,arg2,type3,arg3)		\
type									\
name (type1 arg1, type2 arg2, type3 arg3)				\
{									\
	register long dummy4 __asm__ ("out3");				\
	register long dummy5 __asm__ ("out4");				\
	long     ret;												\
	ret = __ia64_syscall((long) arg1, (long) arg2, (long) arg3,	\
			      dummy4, dummy5, __NR_##name);		\
	return (ret < 0) ? -errno : 0; \
}

#define _newsyscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4)	\
type										\
name (type1 arg1, type2 arg2, type3 arg3, type4 arg4)				\
{										\
	register long dummy5 __asm__ ("out4");					\
	long     ret;													\
	ret = __ia64_syscall((long) arg1, (long) arg2, (long) arg3,		\
			      (long) arg4, dummy5, __NR_##name);		\
	return (ret < 0) ? -errno : 0; \
}

#define _newsyscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4,type5,arg5)	\
type											\
name (type1 arg1, type2 arg2, type3 arg3, type4 arg4, type5 arg5)			\
{											\
	long     ret; 																		\
	ret = __ia64_syscall((long) arg1, (long) arg2, (long) arg3,			\
			      (long) arg4, (long) arg5, __NR_##name);			\
	return (ret < 0) ? -errno : 0; \
}

#elif defined(ARCH_ALPHA)

#define _newsyscall_return(type)						\
	return (_sc_err ? : _sc_ret = 0), (type) _sc_ret


#define _syscall_clobbers						\
	"$1", "$2", "$3", "$4", "$5", "$6", "$7", "$8",			\
	"$22", "$23", "$24", "$25", "$27", "$28" 			\

#define _newsyscall1(type,name,type1,arg1)					\
type name(type1 arg1)							\
{									\
	long _sc_ret, _sc_err;						\
	{								\
		register long _sc_0 __asm__("$0");			\
		register long _sc_16 __asm__("$16");			\
		register long _sc_19 __asm__("$19");			\
									\
		_sc_0 = __NR_##name;					\
		_sc_16 = (long) (arg1);					\
		__asm__("callsys # %0 %1 %2 %3"				\
			: "=r"(_sc_0), "=r"(_sc_19)			\
			: "0"(_sc_0), "r"(_sc_16)			\
			: _syscall_clobbers);				\
		_sc_ret = _sc_0, _sc_err = _sc_19;			\
	}								\
	_newsyscall_return(type);						\
}

#define _newsyscall2(type,name,type1,arg1,type2,arg2)			\
type name(type1 arg1,type2 arg2)					\
{									\
	long _sc_ret, _sc_err;						\
	{								\
		register long _sc_0 __asm__("$0");			\
		register long _sc_16 __asm__("$16");			\
		register long _sc_17 __asm__("$17");			\
		register long _sc_19 __asm__("$19");			\
									\
		_sc_0 = __NR_##name;					\
		_sc_16 = (long) (arg1);					\
		_sc_17 = (long) (arg2);					\
		__asm__("callsys # %0 %1 %2 %3 %4"			\
			: "=r"(_sc_0), "=r"(_sc_19)			\
			: "0"(_sc_0), "r"(_sc_16), "r"(_sc_17)		\
			: _syscall_clobbers);				\
		_sc_ret = _sc_0, _sc_err = _sc_19;			\
	}								\
	_newsyscall_return(type);						\
}

#define _newsyscall3(type,name,type1,arg1,type2,arg2,type3,arg3)		\
type name(type1 arg1,type2 arg2,type3 arg3)				\
{									\
	long _sc_ret, _sc_err;						\
	{								\
		register long _sc_0 __asm__("$0");			\
		register long _sc_16 __asm__("$16");			\
		register long _sc_17 __asm__("$17");			\
		register long _sc_18 __asm__("$18");			\
		register long _sc_19 __asm__("$19");			\
									\
		_sc_0 = __NR_##name;					\
		_sc_16 = (long) (arg1);					\
		_sc_17 = (long) (arg2);					\
		_sc_18 = (long) (arg3);					\
		__asm__("callsys # %0 %1 %2 %3 %4 %5"			\
			: "=r"(_sc_0), "=r"(_sc_19)			\
			: "0"(_sc_0), "r"(_sc_16), "r"(_sc_17),		\
			  "r"(_sc_18)					\
			: _syscall_clobbers);				\
		_sc_ret = _sc_0, _sc_err = _sc_19;			\
	}								\
	_newsyscall_return(type);						\
}

#define _newsyscall4(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4) \
type name (type1 arg1, type2 arg2, type3 arg3, type4 arg4)		 \
{									 \
	long _sc_ret, _sc_err;						\
	{								\
		register long _sc_0 __asm__("$0");			\
		register long _sc_16 __asm__("$16");			\
		register long _sc_17 __asm__("$17");			\
		register long _sc_18 __asm__("$18");			\
		register long _sc_19 __asm__("$19");			\
									\
		_sc_0 = __NR_##name;					\
		_sc_16 = (long) (arg1);					\
		_sc_17 = (long) (arg2);					\
		_sc_18 = (long) (arg3);					\
		_sc_19 = (long) (arg4);					\
		__asm__("callsys # %0 %1 %2 %3 %4 %5 %6"		\
			: "=r"(_sc_0), "=r"(_sc_19)			\
			: "0"(_sc_0), "r"(_sc_16), "r"(_sc_17),		\
			  "r"(_sc_18), "1"(_sc_19)			\
			: _syscall_clobbers);				\
		_sc_ret = _sc_0, _sc_err = _sc_19;			\
	}								\
	_newsyscall_return(type);						\
} 

#define _newsyscall5(type,name,type1,arg1,type2,arg2,type3,arg3,type4,arg4, \
	  type5,arg5)							 \
type name (type1 arg1,type2 arg2,type3 arg3,type4 arg4,type5 arg5)	\
{									\
	long _sc_ret, _sc_err;						\
	{								\
		register long _sc_0 __asm__("$0");			\
		register long _sc_16 __asm__("$16");			\
		register long _sc_17 __asm__("$17");			\
		register long _sc_18 __asm__("$18");			\
		register long _sc_19 __asm__("$19");			\
		register long _sc_20 __asm__("$20");			\
									\
		_sc_0 = __NR_##name;					\
		_sc_16 = (long) (arg1);					\
		_sc_17 = (long) (arg2);					\
		_sc_18 = (long) (arg3);					\
		_sc_19 = (long) (arg4);					\
		_sc_20 = (long) (arg5);					\
		__asm__("callsys # %0 %1 %2 %3 %4 %5 %6 %7"		\
			: "=r"(_sc_0), "=r"(_sc_19)			\
			: "0"(_sc_0), "r"(_sc_16), "r"(_sc_17),		\
			  "r"(_sc_18), "1"(_sc_19), "r"(_sc_20)		\
			: _syscall_clobbers);				\
		_sc_ret = _sc_0, _sc_err = _sc_19;			\
	}								\
	_newsyscall_return(type);						\
}

#else 

#error "Atleast one of x86/ia64/alpha must be defined.!"

#endif

static inline _newsyscall3(int,open,const char *,pathname,int,flags,int,mode);
static inline _newsyscall1(int,close,int,fd); 
static inline _newsyscall3(ssize_t,read,int,fd,void *,buf,size_t,count);
static inline _newsyscall3(ssize_t,write,int,fd,const void *,buf,size_t,count);
#ifdef ARCH_X86

static inline _newsyscall2(int,socketcall,int,call,unsigned long *,args);

#elif defined(ARCH_IA64) || defined(ARCH_ALPHA)

static inline _newsyscall3(int, socket, int, domain, int, type, int, protocol);
static inline _newsyscall3(int, bind, int, sockfd, struct sockaddr*, my_addr, int, addrlen);
static inline _newsyscall3(int, connect, int, sockfd, struct sockaddr*, serv_addr, int, addrlen);
static inline _newsyscall2(int, listen, int, sockfd, int, backlog);
static inline _newsyscall3(int, accept, int, sockfd, struct sockaddr*, addr, int*, addrlen);
static inline _newsyscall3(int, getsockname, int, sockfd, struct sockaddr*, name, unsigned int*, namelen);
static inline _newsyscall3(int, getpeername, int, sockfd, struct sockaddr*, name, unsigned int*, namelen);
static inline _newsyscall4(int, socketpair, int, domain, int, type, int, protocol, int*, sv);
static inline _newsyscall4(int, send, int, sockfd, void*, msg, int, len, unsigned int, flags);
static inline _newsyscall4(int, recv, int, sockfd, void*, buf, int, len, unsigned int, flags);
static inline _newsyscall2(int, shutdown, int, sockfd, int, how);
static inline _newsyscall5(int, setsockopt, int, sockfd, int, level, int, optname, void*, optval, unsigned int, optlen);
static inline _newsyscall5(int, getsockopt, int, sockfd, int, level, int, optname, void*, optval, unsigned int*, optlen);

#endif

static inline _newsyscall2(int,stat,const char *,file_name,struct stat *,buf);
static inline _newsyscall2(int,fstat,int,filedes,struct stat *,buf);
static inline _newsyscall2(int,lstat,const char *,file_name,struct stat *,buf);
static inline _newsyscall4(int,sendfile,int,out_fd,int,in_fd,off_t*,offset,size_t,count);
static inline _newsyscall3(int,fcntl,unsigned int,fd,unsigned int,cmd,unsigned long,args);
#ifdef ARCH_X86
static inline _newsyscall5(int,_newselect,int,n,fd_set *,readfds,fd_set *,writefds,fd_set *,exceptfds,struct timeval *,timeout);
#elif defined(ARCH_IA64) || defined(ARCH_ALPHA)
static inline _newsyscall5(int,select,int,n,fd_set *,readfds,fd_set *,writefds,fd_set *,exceptfds,struct timeval *,timeout);
#endif
static inline _newsyscall3(int,writev,int,fd,const struct iovec *,vector,int,count);
static inline _newsyscall3(int,readv,int,fd,const struct iovec *,vector,int,count);
static inline _newsyscall3(int,poll,struct pollfd *,ufds,unsigned int,nfds,int,timeout);

#ifdef ARCH_X86
static inline int select(int n,fd_set *readfds,fd_set *writefds,fd_set *exceptfds,struct timeval *timeout)
{
	return _newselect(n,readfds,writefds,exceptfds,timeout);
}
#endif

static inline int kern_socket(int domain,int type,int protocol)
{
	int sock=-1;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[3];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = domain;
	args[1] = type;
	args[2] = protocol;
	/* this returns an error or the actual socket file descriptor */
	sock = socketcall(SYS_SOCKET,args);
#elif defined(ARCH_IA64) || defined(ARCH_ALPHA)
	sock = socket(domain, type, protocol);
#endif
	set_fs(old_fs);
	return sock;
}

static inline int kern_bind(int sockfd,struct sockaddr *my_addr,int addrlen)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[3];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = (unsigned long)my_addr;
	args[2] = addrlen;
	/* this returns an error or success not -1 */
	err = socketcall(SYS_BIND,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = bind(sockfd, my_addr, addrlen);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_connect(int sockfd,struct sockaddr *serv_addr,int addrlen)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[3];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = (unsigned long)serv_addr;
	args[2] = addrlen;
	/* this returns an error or success not -1 */
	err = socketcall(SYS_CONNECT,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = connect(sockfd, serv_addr, addrlen);
#endif
	set_fs(old_fs);
	return err;
}


static inline int kern_listen(int sockfd,int backlog)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[2];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = backlog;
	/* this returns an error or success not -1 */
	err = socketcall(SYS_LISTEN,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = listen(sockfd, backlog);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_accept(int sockfd,struct sockaddr *addr,int *addrlen)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[3];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = (unsigned long)addr;
	args[2] = (unsigned long)addrlen;
	/* this returns an error or new sock fd not -1 */
	err = socketcall(SYS_ACCEPT,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = accept(sockfd, addr, addrlen);
#endif
	set_fs(old_fs);
	return err;
}


static inline int kern_getsockname(int sockfd,struct sockaddr *name,unsigned int *namelen)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[3];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = (unsigned long)name;
	args[2] = (unsigned long)namelen;
	/* this returns an error or name  */
	err = socketcall(SYS_GETSOCKNAME,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = getsockname(sockfd, name, namelen);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_getpeername(int sockfd,struct sockaddr *name,unsigned int *namelen)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[3];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = (unsigned long)name;
	args[2] = (unsigned long)namelen;
	/* this returns an error or peername  */
	err = socketcall(SYS_GETPEERNAME,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = getpeername(sockfd, name, namelen);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_socketpair(int domain,int type,int protocol,int *sv)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[4];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = domain;
	args[1] = type;
	args[2] = protocol;
	args[3] = (unsigned long)sv;
	/* this returns an error or success  */
	err = socketcall(SYS_SOCKETPAIR,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = socketpair(domain, type, protocol, sv);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_send(int sockfd,void *msg,int len,unsigned int flags)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[4];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = (unsigned long)msg;
	args[2] = len;
	args[3] = flags;
	/* this returns an error or number of bytes sent  */
	err = socketcall(SYS_SEND,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = send(sockfd, msg, len, flags);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_recv(int sockfd,void *buf,int len,unsigned int flags)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[4];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = (unsigned long)buf;
	args[2] = len;
	args[3] = flags;
	/* this returns the error number or the number of bytes read */
	err = socketcall(SYS_RECV,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = recv(sockfd, msg, len, flags);
#endif
	set_fs(old_fs);
	return err;
}


static inline int kern_shutdown(int sockfd,int how)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[2];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = how;
	/* this returns error or success */
	err = socketcall(SYS_SHUTDOWN,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = shutdown(sockfd, how);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_setsockopt(int sockfd,int level,int optname,void *optval,unsigned int optlen)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[5];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = level;
	args[2] = optname;
	args[3] = (unsigned long)optval;
	args[4] = optlen;
	/* this returns error or success */
	err = socketcall(SYS_SETSOCKOPT,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = setsockopt(sockfd, level, optname, optval, optlen);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_getsockopt(int sockfd,int level,int optname,void *optval,unsigned int *optlen)
{
	int err=-EINVAL;
	mm_segment_t old_fs;
#ifdef ARCH_X86
	unsigned long args[5];
#endif
	old_fs = get_fs();
	set_fs(KERNEL_DS);
#ifdef ARCH_X86
	args[0] = sockfd;
	args[1] = level;
	args[2] = optname;
	args[3] = (unsigned long)optval;
	args[4] = (unsigned long)optlen;
	/* this returns error or success */
	err = socketcall(SYS_GETSOCKOPT,args);
#elif defined(ARCH_ALPHA) || defined(ARCH_IA64)
	err = getsockopt(sockfd, level, optname, optval, optlen);
#endif
	set_fs(old_fs);
	return err;
}

static inline int kern_open(const char *pathname,int flags,int mode)
{
	int fd = 0;
	mm_segment_t old_fs;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	fd = open(pathname,flags,mode);
	set_fs(old_fs);
	return fd;
}

static inline ssize_t kern_read(int fd,void *buf,size_t count)
{
	ssize_t ret = 0;
	mm_segment_t old_fs;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = read(fd,buf,count);
	set_fs(old_fs);
	return ret;
}

static inline ssize_t kern_write(int fd,const void *buf,size_t count)
{
	ssize_t ret = 0;
	mm_segment_t old_fs;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = write(fd,buf,count);
	set_fs(old_fs);
	return ret;
}

static inline int kern_fstat(int fd,struct stat *buf)
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = fstat(fd,buf);
	set_fs(old_fs);
	return ret;
}

static inline int kern_stat(const char *pathname,struct stat *buf)
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = stat(pathname,buf);
	set_fs(old_fs);
	return ret;
}

static inline int kern_lstat(const char *pathname,struct stat *buf)
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = lstat(pathname,buf);
	set_fs(old_fs);
	return ret;
}

static inline int kern_select(int  n,fd_set *readfds,fd_set *writefds,fd_set *exceptfds,struct timeval *timeout)
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = select(n,readfds,writefds,exceptfds,timeout);
	set_fs(old_fs);
	return ret;
}

static inline int kern_sendfile(int out_fd,int in_fd, off_t *offset, size_t count)
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = sendfile(out_fd,in_fd,offset,count);
	set_fs(old_fs);
	return ret;
}

static inline int kern_readv(int fd, const struct iovec * vector, int count) 
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = readv(fd,vector,count);
	set_fs(old_fs);
	return ret;
}

static inline int kern_writev(int fd, const struct iovec * vector, int count)
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = writev(fd,vector,count);
	set_fs(old_fs);
	return ret;
}

static inline int kern_poll(struct pollfd *ufds, unsigned int nfds, int timeout)
{
	mm_segment_t old_fs;
	int ret = 0;
	old_fs = get_fs();
	set_fs(KERNEL_DS);
	ret = poll(ufds,nfds,timeout);
	set_fs(old_fs);
	return ret;
}

/* Atlast we get to the exported functions to user-space/kernel-space clients */
int Open(const char *pathname, int flags, int mode)
{
	return kern_open(pathname, flags, mode);
}

int Close(int fd)
{
	return close(fd);
}

ssize_t Read(int fd, void *buf, size_t count)
{
	return kern_read(fd, buf, count);
}


ssize_t Write(int fd, const void *buf, size_t count)
{
	return kern_write(fd, buf, count);
}

int Fstat(int filedes, struct stat *buf)
{
	return kern_fstat(filedes,buf);
}

int Stat(const char *pathname, struct stat *buf)
{
	return kern_stat(pathname, buf);
}

int Lstat(const char* pathname, struct stat *buf)
{
	return kern_lstat(pathname, buf);
}

int Fcntl(unsigned int fd, unsigned int cmd, unsigned long args)
{
	return fcntl(fd, cmd, args);
}

int Socket(int domain,int type,int protocol)
{
	return kern_socket(domain,type,protocol);
}

int Bind(int sockfd,struct sockaddr *my_addr,int addrlen)
{
	return kern_bind(sockfd,my_addr,addrlen);
}

int Connect(int sockfd,struct sockaddr *serv_addr,int addrlen)
{
	return kern_connect(sockfd, serv_addr, addrlen);
}

int Listen(int sockfd,int backlog)
{
	return kern_listen(sockfd, backlog);
}

int Accept(int sockfd,struct sockaddr *addr,int *addrlen)
{
	return kern_accept(sockfd, addr, addrlen);
}

int Getsockname(int sockfd,struct sockaddr *name,unsigned int *namelen)
{
	return kern_getsockname(sockfd, name, namelen);
}

int Getpeername(int sockfd,struct sockaddr *name,unsigned int *namelen)
{
	return kern_getpeername(sockfd,name,namelen);
}

int Socketpair(int domain,int type,int protocol,int *sv)
{
	return kern_socketpair(domain,type,protocol,sv);
}

int Send(int sockfd,void *msg,int len,unsigned int flags)
{
	return kern_send(sockfd, msg, len,flags);
}

int Recv(int sockfd,void *buf,int len,unsigned int flags)
{
	return kern_recv(sockfd, buf, len, flags);
}

int Shutdown(int sockfd,int how)
{
	return kern_shutdown(sockfd, how);
}

int Setsockopt(int sockfd,int level,int optname,void *optval,unsigned int optlen)
{
	return kern_setsockopt(sockfd, level, optname, optval, optlen);
}

int Getsockopt(int sockfd,int level,int optname,void *optval,unsigned int *optlen)
{
	return kern_getsockopt(sockfd, level, optname, optval, optlen);
}

int Select(int n, fd_set *readfds, fd_set *writefds, fd_set *except_fds, struct timeval *timeout)
{
	return kern_select(n, readfds, writefds, except_fds, timeout);
}

int Sendfile(int out_fd, int in_fd, off_t *offset, size_t count)
{
	return kern_sendfile(out_fd, in_fd, offset, count);
}

int Readv(int fd,const struct iovec *vector, int count)
{
	return kern_readv(fd, vector, count);
}

int Writev(int fd, const struct iovec *vector, int count)
{
	return kern_writev(fd, vector, count);
}

int Poll(struct pollfd *ufds, unsigned int nfds, int timeout)
{
	return kern_poll(ufds, nfds, timeout);
}

/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 * End:
 *
 * vim: ts=3
 */
