/*
 * (C) 1995-2004 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */

/*************************************
 * Phil Carns    Nov 99   Parl Lab
 * Test code for pvfsd kernel communication
 * This one writes a request into the device file
 ***************************************/

/* these three are included to make the types in ll_pvfs.h work */
#include <stdint.h>
#include <inttypes.h>
#include <time.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>

#include "../ll_pvfs.h"

#define TEST_UPWAIT 667
#define TEST_CHEAT_DEC 669
#define TEST_RD_XFER 670
#define TEST_WR_XFER 672

struct ioctl_mem_reg{
	void* ptr;
	pvfs_size_t size;


};


int main(int argc, char **argv){

	int devfile = -1;
	int testfile = -1;
	char *buffer = NULL;
	int bufsz = 0;

	if(argc == 1){
		printf("0 to test enq_wait, 1 to dec module count, 2 to test memory\n
		transfers with a read from the application, 3 to do the same thing\n
		with a write\n");
		return(0);
	}
	if((argc > 2)&&(atoi(argv[1]) != 2)){
		printf("dumbass.\n");
		exit(-1);
	}

	devfile = open("/dev/pvfsd", O_RDONLY);
	if(devfile < 0){
		perror("open");
		exit(-1);
	}

	if(atoi(argv[1]) == 0){
		if(ioctl(devfile, TEST_UPWAIT, NULL) < 0){
			printf("ioctl failed.\n");
		}
		else{
			printf("ioctl succeded.\n");
		}
	}
	if(atoi(argv[1]) == 1){
		if(ioctl(devfile, TEST_CHEAT_DEC, NULL) < 0){
			printf("ioctl failed.\n");
		}
		else{
			printf("ioctl succeded.\n");
		}
	}
	if(atoi(argv[1]) == 2){
		struct ioctl_mem_reg my_buf;
		bufsz = atoi(argv[2]);
		if((buffer = (char*)malloc(bufsz)) == NULL){
			perror("malloc");
			exit(-1);
		}

		if((testfile = open("testout.txt", O_WRONLY|O_CREAT)) == -1){
			perror("open");
		}
		printf("original user buffer being mapped: %lx\n", (long)buffer);
		my_buf.ptr = buffer;
		my_buf.size = bufsz;
		printf("before ioctl:\n");
		if(ioctl(devfile, TEST_RD_XFER, &my_buf) < 0){
			printf("ioctl failed.\n");
		}
		else{
			printf("ioctl succeded.\n");
		}
		printf("after ioctl:\n");
		if((write(testfile, buffer, bufsz)) != bufsz){
			perror("write");
		}
		close(testfile);
	}
	if(atoi(argv[1]) == 3){
		pvfs_char_t trashme[] = "Boom\n";
		struct ioctl_mem_reg my_buf;
		my_buf.ptr = trashme;
		my_buf.size = strlen(trashme);
		printf("before ioctl:\n");
		printf(trashme);
		if(ioctl(devfile, TEST_WR_XFER, &my_buf) < 0){
			printf("ioctl failed.\n");
		}
		else{
			printf("ioctl succeded.\n");
		}
		printf("after ioctl:\n");
		printf(trashme);
	}
	close(devfile);

	return(0);
}

/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 *
 * vim: ts=3
 * End:
 */ 
