/*
 * (C) 1995-2004 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */

/*************************************
 * Phil Carns    Nov 99   Parl Lab
 * Test code for pvfsd kernel communication
 * This one writes a request into the device file
 ***************************************/

/* these three are included to make the types in ll_pvfs.h work */
#include <stdint.h>
#include <inttypes.h>
#include <time.h>

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "../ll_pvfs.h"


int main(int argc, char **argv){

	struct pvfs_upcall *putreq = NULL;
	int devfile = -1;
	int req_sz = sizeof(struct pvfs_upcall);
	int read_sz = 0;

	if(argc != 1){
		printf("dumbass.\n");
		exit(-1);
	}

	putreq = (struct pvfs_upcall*)malloc(req_sz);
	if(!putreq){
		perror("malloc");
		exit(-1);
	}

	devfile = open("/dev/pvfsd", O_RDONLY);
	if(devfile < 0){
		perror("open");
		exit(-1);
	}

	read_sz = read(devfile, putreq, req_sz);
	if((read_sz!=0)&&(read_sz<req_sz)){
		perror("read");
		close(devfile);
		exit(-1);
	}
	else if(read_sz==0){
		printf("No data available.\n");
		close(devfile);
		return(0);
	}

	if(putreq->magic != PVFS_UPCALL_MAGIC){
		printf("Bad magic.\n");
	}
	printf("Recieved number: %d\n", putreq->seq);

	close(devfile);

	return(0);
}

/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 *
 * vim: ts=3
 * End:
 */ 
